#!/usr/bin/perl -- # -*- perl -*-

# Erik E. Peterson, author
# Comments, corrections to eepeter@erols.com
# April, 1997
# Program free for noncommercial use.  Please redistribute freely
# as long as this credit section is included.

# Call with name of file to convert as an argument.  File will be
# *replaced* with converted version.

die "Please supply 1 file name" if ($#ARGV < 0);

for ($i = 129; $i < 257; $i++) {
    $a2c{"\&\#$i"} = pack("C", $i);
    #print $a2c{"\&\#$i"};
}

$a2c{'&iexcl'} = pack("C", 161);
$a2c{'&cent'} = pack("C", 162);
$a2c{'&pound'} = pack("C", 163);
$a2c{'&curren'} = pack("C", 164);
$a2c{'&yen'} = pack("C", 165);
$a2c{'&brvbar'} = pack("C", 166);
$a2c{'&sect'} = pack("C", 167);
$a2c{'&uml'} = pack("C", 168);
$a2c{'&copy'} = pack("C", 169);
$a2c{'&ordf'} = pack("C", 170);
$a2c{'&laquo'} = pack("C", 171);
$a2c{'&not'} = pack("C", 172);
$a2c{'&shy'} = pack("C", 173);
$a2c{'&reg'} = pack("C", 174);
$a2c{'&macr'} = pack("C", 175);
$a2c{'&deg'} = pack("C", 176);
$a2c{'&plusmn'} = pack("C", 177);
$a2c{'&sup2'} = pack("C", 178);
$a2c{'&sup3'} = pack("C", 179);
$a2c{'&acute'} = pack("C", 180);
$a2c{'&micro'} = pack("C", 181);
$a2c{'&para'} = pack("C", 182);
$a2c{'&middot'} = pack("C", 183);
$a2c{'&cedil'} = pack("C", 184);
$a2c{'&sup1'} = pack("C", 185);
$a2c{'&ordm'} = pack("C", 186);
$a2c{'&raquo'} = pack("C", 187);
$a2c{'&frac14'} = pack("C", 188);
$a2c{'&frac12'} = pack("C", 189);
$a2c{'&frac34'} = pack("C", 190);
$a2c{'&iquest'} = pack("C", 191);
$a2c{'&Agrave'} = pack("C", 192);
$a2c{'&Aacute'} = pack("C", 193);
$a2c{'&Acirc'} = pack("C", 194);
$a2c{'&Atilde'} = pack("C", 195);
$a2c{'&Auml'} = pack("C", 196);
$a2c{'&Aring'} = pack("C", 197);
$a2c{'&AElig'} = pack("C", 198);
$a2c{'&Ccedil'} = pack("C", 199);
$a2c{'&Egrave'} = pack("C", 200);
$a2c{'&Eacute'} = pack("C", 201);
$a2c{'&Ecirc'} = pack("C", 202);
$a2c{'&Euml'} = pack("C", 203);
$a2c{'&Igrave'} = pack("C", 204);
$a2c{'&Iacute'} = pack("C", 205);
$a2c{'&Icirc'} = pack("C", 206);
$a2c{'&Iuml'} = pack("C", 207);
$a2c{'&ETH'} = pack("C", 208);
$a2c{'&Dstrok'} = pack("C", 208);
$a2c{'&Ntilde'} = pack("C", 209);
$a2c{'&Ograve'} = pack("C", 210);
$a2c{'&Oacute'} = pack("C", 211);
$a2c{'&Ocirc'} = pack("C", 212);
$a2c{'&Otilde'} = pack("C", 213);
$a2c{'&Ouml'} = pack("C", 214);
$a2c{'&times'} = pack("C", 215);
$a2c{'&Oslash'} = pack("C", 216);
$a2c{'&Ugrave'} = pack("C", 217);
$a2c{'&Uacute'} = pack("C", 218);
$a2c{'&Ucirc'} = pack("C", 219);
$a2c{'&Uuml'} = pack("C", 220);
$a2c{'&Yacute'} = pack("C", 221);
$a2c{'&THORN'} = pack("C", 222);
$a2c{'&szlig'} = pack("C", 223);
$a2c{'&agrave'} = pack("C", 224);
$a2c{'&aacute'} = pack("C", 225);
$a2c{'&acirc'} = pack("C", 226);
$a2c{'&atilde'} = pack("C", 227);
$a2c{'&auml'} = pack("C", 228);
$a2c{'&aring'} = pack("C", 229);
$a2c{'&aelig'} = pack("C", 230);
$a2c{'&ccedil'} = pack("C", 231);
$a2c{'&egrave'} = pack("C", 232);
$a2c{'&eacute'} = pack("C", 233);
$a2c{'&ecirc'} = pack("C", 234);
$a2c{'&euml'} = pack("C", 235);
$a2c{'&igrave'} = pack("C", 236);
$a2c{'&iacute'} = pack("C", 237);
$a2c{'&icirc'} = pack("C", 238);
$a2c{'&iuml'} = pack("C", 239);
$a2c{'&eth'} = pack("C", 240);
$a2c{'&ntilde'} = pack("C", 241);
$a2c{'&ograve'} = pack("C", 242);
$a2c{'&oacute'} = pack("C", 243);
$a2c{'&ocirc'} = pack("C", 244);
$a2c{'&otilde'} = pack("C", 245);
$a2c{'&ouml'} = pack("C", 246);
$a2c{'&divide'} = pack("C", 247);
$a2c{'&oslash'} = pack("C", 248);
$a2c{'&ugrave'} = pack("C", 249);
$a2c{'&uacute'} = pack("C", 250);
$a2c{'&ucirc'} = pack("C", 251);
$a2c{'&uuml'} = pack("C", 252);
$a2c{'&yacute'} = pack("C", 253);
$a2c{'&thorn'} = pack("C", 254);
$a2c{'&yuml'} = pack("C", 255);


open(AFILE, $ARGV[0]);
open(OFILE, "> ampfile.tmp");

while ($line = <AFILE>) {
    $line =~ s/(\&\#?[0-9A-Za-z]+)\;/$a2c{$1}/g;
    print OFILE $line;
}

close AFILE;
close OFILE;

rename("ampfile.tmp", $ARGV[0]);
